#!/bin/bash

# Variablen
mydir=$PWD

# Intro
echo -e "\n Danke, dass du Backuppy nutzt, um deine Backups zu erstellen! \n"
sleep 2
echo -e "Der Installer wird dich nun einige Dinge abfragen, um dein Backup-Skript an deine Anforderungen anzupassen. \n"
sleep 2
# Installer

# fragt ab, ob der User eine Logdatei mit allen Fehlermeldungen drin haben möchte und ob da auch das Datum des Backupstarts und -Ende drin stehen soll
echo -e "möchtest du eine Logdatei haben, in welche Backuppy dann das Datum vom Backup-Start/-Ende und allfällige Fehlermeldungen eintragen wird? [J/N] \n Standardmässig ist eine Logdatei aktiviert."
read logfile

if [ $logfile = "J" ]; then
    echo -e "Super! Standardmässig existiert die Logdatei, also muss ich nichts ändern. \n"
    sleep 2
fi
if [ $logfile = "N" ]; then
    echo -e "okay, dann lösche ich nun die standardmässig vorhandene Logdatei. \n"
    rm Backup.log
    sleep 2
fi

# welche Rsync-Optionen zur Verfügung stehen und welche man benutzen möchte
echo -e "rsync bietet verschiedene Optionen an, um das Ganze jedoch zu vereinfachen, habe ich die Optionen -a, -q und -p aktiviert. \n Wenn du mehr einstellen willst, kannst du das in der Datei 'Backuppy.sh' machen. \n"
sleep 2

# fragt, ob man Dateien/Verzeichnisse vom Backup ausschliessen will und erstellt im Falle von Ja eine Exclude Datei
echo -e "Nun muss ich noch wissen, ob du ein oder mehrere Dateien/Verzeichnisse vom Backup ausschliessen möchtest. Dann kannst du das in der 'exclude.txt' anpassen. \n Dort kannst du dann im Format '/Verzeichnis' '/Datei.txt' Verzeichnisse und Dateien ausschliessen.\n Möchtest du Dateien/Verzeichnisse ausschliessen oder nicht? [J/N]"
read exclude
if [ $exclude = "J" ]; then
    echo -e "Perfekt, dann kannst du nach der Fertigstellung der Installation von Backuppy deine auszuschliessenden Dateien/Verzeichnisse in der Datei 'exclude.txt eintragen. \n"
    sleep 2
fi
if [ $exclude = "N" ]; then
    echo -e "Gut, dann lösche ich die exclude.txt Datei, da du sie ja nicht brauchst. \n"
    rm exclude.txt
    sleep 2
fi

# Fragt das Quellverzeichnis, welches gesichert werden soll, ab
echo -e "Nun kommen wir zu einem der wichtigesten Teile der Installation von Backuppy:"
sleep 1
echo -e "Welches Verzeichnis möchtest du sichern (z.B. das Homeverzeichnis)? Bitte gib einen absoluten Pfad (z.B. '/home/username/') an."
read sourcedir
echo -e "du hast folgenden Quellpfad eingetippt: $sourcedir wenn dieser Pfad nicht stimmen sollte, dann passe ihn in der Datei 'backuppy.sh' an"
sleep 2

# fragt das Zielverzeichnis, auf welchem das Backup gesichert werden soll, ab
echo -e "Nun muss ich noch wissen, wo Backuppy dein Backup ablegen soll, das Zielverzeichnis also. \n Bitte tippe dieses gewissenhaft und auf die Weise wie beim Quellverzeichnis ein."
read targetdir
echo -e "du hast folgenden Zielpfad eingetippt: $targetdir wenn dieser Pfad nicht stimmen sollte, dann passe ihn in der Datei 'backuppy.sh' an"
sleep 2

# Programmeintrag in die .bashrc oder .zshrc
#zshrc
echo "$SHELL"
if [ $SHELL = "/usr/bin/zsh" ]; then
    echo "alias backuppy='sudo $mydir/backuppy.sh'" >> ~/.zshrc
fi
#bashrc
if [ $SHELL = "/usr/bin/bash" ]; then
    echo "alias backuppy='sudo $mydir/backup-tool.sh'" >> ~/.bashrc
fi

# trägt alle Informationen zusammen und erstellt so den rsync-Befehl.
echo -e "Nun sind wir fast am Ende des Installers angelangt. Ich erstelle nun den rsync-Befehl für dich und zeige ihn dir nachher nochmal. \n Wenn dir da etwas auffallen sollte, brich den Installer einfach ab und fange nochmal von Vorne an. \n Achtung: ich empfehle dir, Backuppy in diesem Fall nochmal komplett neu zu installieren. \n"
sleep 2
echo -e "rsync -aqp --exclude-from=$mydir/exclude.txt $sourcedir $targetdir \n"
sleep 2
# eintragen der Configs

echo "rsync -aqp --exclude-from=$mydir/exclude.txt $sourcedir $targetdir" >> Backuppy.sh

# Outro
echo -e "Perfekt, jetzt sind wir fertig. Nun kannst du Backuppy im Terminal mit dem Befehl 'backuppy' starten. Möglicherweise musst du dann noch dein Passwort eintippen, damit Backuppy ordnungsgemäss arbeiten kann."
